<template>
  <div class="page">
    <a-page-header :ghost="false" title="支付管理">
      <!--      <div class="ele-text-secondary"> 商户管理 </div>-->
    </a-page-header>
    <div class="ele-body">
      <a-card :bordered="false">
        <!-- 表格 -->
        <ele-pro-table
          ref="tableRef"
          row-key="paymentId"
          :columns="columns"
          :height="tableHeight"
          :datasource="datasource"
          v-model:selection="selection"
          :scroll="{ x: 800 }"
        >
          <template #toolbar>
            <search
              :selection="selection"
              @search="reload"
              @add="openEdit"
              @remove="removeBatch"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'logo'">
              <a-image :src="record.logo" :preview="false" :width="80" />
            </template>
            <template v-if="column.key === 'paymentName'">
              <a-tooltip
                :title="`商户编号：${record.paymentCode}`"
                placement="topLeft"
              >
                <p class="twoline-hide">
                  {{ record.paymentName }}
                </p>
              </a-tooltip>
            </template>
            <template v-if="column.key === 'status'">
              <a-tag v-if="record.status === 0" color="green">营业中</a-tag>
              <a-tag v-if="record.status === 1" color="orange">停业中</a-tag>
            </template>
            <template v-if="column.key === 'comments'">
              <a-tooltip :title="record.comments" placement="topLeft">
                {{ record.comments }}
              </a-tooltip>
            </template>
            <template v-if="column.key === 'createTime'">
              <a-tooltip :title="`${toDateString(record.createTime)}`">
                {{ timeAgo(record.createTime) }}
              </a-tooltip>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a @click="onPay(record)">支付测试</a>
                <a-divider type="vertical" />
                <a @click="openEdit(record)">编辑</a>
                <a-divider type="vertical" />
                <a-popconfirm
                  title="确定要删除此记录吗？"
                  @confirm="remove(record)"
                >
                  <a class="ele-text-danger">删除</a>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>
      <!-- 编辑弹窗 -->
      <Edit v-model:visible="showEdit" :data="current" @done="reload" />
      <!-- 账号管理 -->
      <payment-user v-model:visible="showUser" :data="current" @done="reload" />
    </div>
  </div>
</template>

<!--suppress TypeScriptValidateTypes -->
<script lang="ts" setup>
  import { timeAgo } from 'ele-admin-pro';
  import { createVNode, computed, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import { toDateString } from 'ele-admin-pro';
  import Search from './components/search.vue';
  import Edit from './components/edit.vue';
  import PaymentUser from './components/clerk.vue';
  import { Category } from '@/api/goods/category/model';
  import {
    pagePayment,
    removePayment,
    removeBatchPayment,
    alipay
  } from '@/api/system/payment';
  import type { Payment, PaymentParam } from '@/api/system/payment/model';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 当前用户信息
  // const brand = getDictionaryOptions('serverBrand');

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      key: 'index',
      width: 48,
      align: 'center',
      fixed: 'left',
      hideInSetting: true,
      customRender: ({ index }) => index + (tableRef.value?.tableIndex ?? 0)
    },
    {
      title: '名称',
      dataIndex: 'method'
    },
    // {
    //   title: '支付方式',
    //   dataIndex: 'paymentCode'
    // },
    // {
    //   title: '支付模板',
    //   dataIndex: 'templateId',
    //   key: 'templateId'
    // },
    // {
    //   title: '默认',
    //   dataIndex: 'isDefault',
    //   key: 'isDefault'
    // },
    // {
    //   title: '状态',
    //   dataIndex: 'status',
    //   sorter: true,
    //   key: 'status',
    //   showSorterTooltip: false,
    //   customRender: ({ text }) => ['上架', '下架'][text]
    // },
    // {
    //   title: '排序',
    //   dataIndex: 'sortNumber',
    //   hideInTable: true,
    //   sorter: true
    // },
    // {
    //   title: '创建时间',
    //   dataIndex: 'createTime',
    //   key: 'createTime',
    //   sorter: true,
    //   ellipsis: true,
    //   hideInTable: true,
    //   customRender: ({ text }) => toDateString(text)
    // },
    {
      title: '操作',
      key: 'action',
      width: 200,
      align: 'center',
      hideInSetting: true
    }
  ]);

  // 表格选中数据
  const selection = ref<Payment[]>([]);
  // 当前编辑数据
  const current = ref<Payment | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  const showUser = ref(false);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.brand = filters.brand;
    }
    return pagePayment({ ...where, ...orders, page, limit });
  };

  /* 搜索 */
  const reload = (where?: PaymentParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  // 搜索是否展开
  const searchExpand = ref(false);

  // 表格固定高度
  const fixedHeight = ref(false);

  // 表格高度
  const tableHeight = computed(() => {
    return fixedHeight.value
      ? searchExpand.value
        ? 'calc(100vh - 618px)'
        : 'calc(100vh - 562px)'
      : void 0;
  });

  /* 打开编辑弹窗 */
  const openEdit = (row?: Payment) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  const onPay = (row: PaymentParam) => {
    alipay(row).then((res) => {
      console.log(res, '>>>>>00');
    });
  };

  /* 删除单个 */
  const remove = (row: Payment) => {
    const hide = message.loading('请求中..', 0);
    removePayment(row.paymentId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchPayment(selection.value.map((d) => d.paymentId))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };
</script>

<script lang="ts">
  export default {
    name: 'PaymentIndex'
  };
</script>

<style lang="less" scoped>
  // 文字超出隐藏(两行)
  // 需要设置文字容器的宽度
  .twoline-hide {
    width: 320px;
    display: -webkit-box;
    -webkit-line-clamp: 2;
    -webkit-box-orient: vertical;
    overflow: hidden;
    white-space: normal;
  }
</style>
